%define section         non-free

%define origin          bea
%define priority        1410
%define javaver         1.4.1
%define buildver        05

%define name            java-%{javaver}-%{origin}
%define version         %{javaver}.%{buildver}
%define release         1jpp

%define sdklnk          java-%{javaver}-%{origin}
%define jrelnk          jre-%{javaver}-%{origin}
%define sdkdir          %{name}-%{version}
%define jredir          %{sdkdir}/jre
%define sdkbindir       %{_jvmdir}/%{sdklnk}/bin
%define jrebindir       %{_jvmdir}/%{jrelnk}/bin
%define jvmjardir       %{_jvmjardir}/%{name}-%{version}

%define x11bindir       %{_prefix}/X11R6/bin
%define x11encdir       %{_prefix}/X11R6/lib/X11/fonts/encodings
%define fontconfigdir   %{_sysconfdir}/fonts
%define fontdir         %{_datadir}/fonts/java
%define xsldir          %{_datadir}/sgml/%{name}-%{version}

# This prevents aggressive stripping on RHL 9.
%define debug_package %{nil}

# Avoid RPM 4.2+'s internal dep generator, it produces bogus Provides here.
%define _use_internal_dependency_generator 0

Name:           %{name}
Version:        %{version}
Release:        %{release}
Epoch:          0
Summary:        BEA WebLogic JRockit

Group:          Development/Interpreters
License:        BEA WebLogic JRockit Binary License
URL:            http://www.bea.com/framework.jsp?CNT=index.htm&FP=/content/products/jrockit
Vendor:         JPackage Project
Distribution:   JPackage
Source0:        http://download2.bea.com/pub/jrockit/81/jrockit-8.1sp2-j2se1.4.1-linux32.bin
Source1:        register-java-fonts.xsl
Source2:        unregister-java-fonts.xsl
Source3:        %{name}.README.jpackage
NoSource:       0
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:      i386

Conflicts:      kaffe
BuildRequires:  jpackage-utils >= 0:1.5, unzip
Provides:       jrockit = %{epoch}:8.1-1.sp2.%{release}
Provides:       jre-%{javaver}-%{origin} = %{epoch}:%{version}, jre-%{javaver}
Provides:       jre-%{origin} = %{epoch}:%{version}, jre = %{javaver}
Provides:       java-%{javaver}, java-%{origin} = %{epoch}:%{version}
Provides:       java = %{javaver}
Provides:       jndi = %{epoch}:%{version}, jndi-ldap = %{epoch}:%{version}
Provides:       jndi-cos = %{epoch}:%{version}, jndi-rmi = %{epoch}:%{version}
Provides:       jndi-dns = %{epoch}:%{version}
Provides:       jaas = %{epoch}:%{version}
Provides:       jsse = %{epoch}:%{version}
Provides:       jce = %{epoch}:%{version}
Provides:       jdbc-stdext = 3.0, jdbc-stdext = %{epoch}:%{version}

%description
BEA WebLogic JRockit Java Virtual Machine delivers superior
application performance, reliability, and manageability for
mission-critical Java applications running on Intel
platforms. Customers can now achieve ROI at all levels of the
infrastructure stack.
JRockit is the first and only JVM that is designed from the ground-up
specifically to address the unique requirements of server-side Java
applications.
A crucial component of the BEA WebLogic Enterprise Platform, BEA
WebLogic JRockit is highly flexible and can be customized to address
the unique performance demands of your applications.

See <http://edocs.bea.com/wljrockit/docs81/> for more information,
including info about supported platforms.

%package        devel
Summary:        BEA WebLogic JRockit SDK
Group:          Development/Compilers
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       %{_sbindir}/update-alternatives
Provides:       java-sdk-%{javaver}-%{origin} = %{epoch}:%{version}
Provides:       java-sdk-%{origin} = %{epoch}:%{version}
Provides:       java-sdk-%{javaver} = %{javaver}, java-sdk = %{javaver}
Provides:       java-devel-%{origin} = %{epoch}:%{version}
Provides:       java-%{javaver}-devel = %{javaver}, java-devel = %{javaver}

%description    devel
%{summary}.

%package        jdbc
Summary:        BEA WebLogic JRockit JDBC/ODBC files
Group:          Development/Libraries/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description    jdbc
%{summary}.

%package        console
Summary:        BEA WebLogic JRockit management console
Group:          Development/Interpreters
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description    console
%{summary}.

%package        fonts
Summary:        TrueType fonts for BEA WebLogic JRockit
Group:          Text Processing/Fonts
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       %{_sbindir}/chkfontpath, %{x11bindir}/mkfontdir, mktemp
Requires:       %{_bindir}/ttmkfdir, %{_bindir}/xsltproc, %{_bindir}/perl
Provides:       java-fonts = %{javaver}, java-%{javaver}-fonts
Conflicts:      java-%{javaver}-ibm-fonts, java-%{javaver}-blackdown-fonts
Conflicts:      java-%{javaver}-sun-fonts
Obsoletes:      java-1.3.1-fonts, java-1.4.0-fonts

%description    fonts
%{summary}.


%prep
%setup -q -c -T
unzip -qq %{SOURCE0}
unzip -qq linux*_jdk.zip     -d _jpp
unzip -qq linux*_jrockit.zip -d _jpp
find _jpp -type f -exec chmod 0644 {} ';'
find _jpp -type d -exec chmod 0755 {} ';'
chmod -R 0755 _jpp/bin _jpp/jre/bin
chmod    0755 _jpp/jre/lib/i386/*.so
chmod    0755 _jpp/jre/lib/i386/awt_robot
chmod    0755 _jpp/jre/lib/i386/jrockit/*.so
chmod    0755 _jpp/jre/lib/i386/native_threads/*.so
mkdir _docs
mv _jpp/*.TXT _jpp/*.txt _docs
install -m 0644 %{SOURCE3} _docs/README.jpackage


%build


%install
rm -rf $RPM_BUILD_ROOT

# main files
install -d -m 0755 $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir}
cp -a _jpp/{bin,include,lib} $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir}
install -d -m 0755 $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}

# extensions handling
install -d -m 0755 $RPM_BUILD_ROOT%{jvmjardir}
pushd $RPM_BUILD_ROOT%{jvmjardir}
  ln -s %{_jvmdir}/%{jredir}/lib/jsse.jar jsse-%{version}.jar
  ln -s %{_jvmdir}/%{jredir}/lib/jce.jar  jce-%{version}.jar
  ln -s %{_jvmdir}/%{jredir}/lib/rt.jar   jndi-%{version}.jar
  ln -s %{_jvmdir}/%{jredir}/lib/rt.jar   jndi-ldap-%{version}.jar
  ln -s %{_jvmdir}/%{jredir}/lib/rt.jar   jndi-cos-%{version}.jar
  ln -s %{_jvmdir}/%{jredir}/lib/rt.jar   jndi-rmi-%{version}.jar
  ln -s %{_jvmdir}/%{jredir}/lib/rt.jar   jaas-%{version}.jar
  ln -s %{_jvmdir}/%{jredir}/lib/rt.jar   jdbc-stdext-%{version}.jar
  ln -s jdbc-stdext-%{version}.jar        jdbc-stdext-3.0.jar
  for jar in *-%{version}.jar ; do
    ln -sf ${jar} $(echo $jar | sed "s|-%{version}.jar|-%{javaver}.jar|g")
    ln -sf ${jar} $(echo $jar | sed "s|-%{version}.jar|.jar|g")
  done
popd

# no plugin
cp -a _jpp/jre/* $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}

# versionless symlinks
pushd $RPM_BUILD_ROOT%{_jvmdir}
ln -s %{jredir} %{jrelnk}
ln -s %{sdkdir} %{sdklnk}
popd
pushd $RPM_BUILD_ROOT%{_jvmjardir}
ln -s %{sdkdir} %{jrelnk}
ln -s %{sdkdir} %{sdklnk}
popd

# no webstart

# no man pages

# no demo

# font handling
pushd $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}/lib

  # Remove font.properties and use the system-wide one -- NiM
  rm -f font.properties
  ln -fs %{_sysconfdir}/java/font.properties .

  # remove supplied fonts.dir in preference of the one to be dynamically
  # generated -- Rex
  rm fonts/fonts.dir

  # These %ghost'd files are created properly in %post  -- Rex
  touch fonts/{fonts.{alias,dir,scale,cache-1},XftCache,encodings.dir}
  if [ "%{fontdir}" != "%{jredir}/lib/fonts" ] ; then
    install -d -m 0755 $RPM_BUILD_ROOT%{fontdir}
    mv fonts/* $RPM_BUILD_ROOT%{fontdir}
    rmdir fonts
    ln -sf %{fontdir} fonts
  fi

popd

# font registration/unregistration
install -d -m 0755 $RPM_BUILD_ROOT%{xsldir}
install -m 0644 %{SOURCE1} %{SOURCE2} $RPM_BUILD_ROOT%{xsldir}

# console files
cp -pr _jpp/console $RPM_BUILD_ROOT%{_jvmdir}/%{name}-%{version}

# generate file lists
find $RPM_BUILD_ROOT%{_jvmdir}/%{jredir} -type d \
  | sed "s|^$RPM_BUILD_ROOT|%dir |" >  %{name}-%{version}-all.files
find $RPM_BUILD_ROOT%{_jvmdir}/%{jredir} -type f -o -type l \
  | sed "s|^$RPM_BUILD_ROOT||"      >> %{name}-%{version}-all.files

grep    Jdbc %{name}-%{version}-all.files > %{name}-%{version}-jdbc.files
grep -v Jdbc %{name}-%{version}-all.files | \
                 grep -v jre/lib/security > %{name}-%{version}.files

find $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir}/bin -type f -a ! -name "console" \
  | sed "s|^$RPM_BUILD_ROOT||"      > %{name}-%{version}-sdk-bin.files


%post

  update-alternatives --install %{_bindir}/java \
    java %{jrebindir}/java %{priority} \
    --slave %{_jvmdir}/jre         jre         %{_jvmdir}/%{jrelnk} \
    --slave %{_jvmjardir}/jre      jre_exports %{_jvmjardir}/%{jrelnk} \
    --slave %{_bindir}/keytool     keytool     %{jrebindir}/keytool \
    --slave %{_bindir}/orbd        orbd        %{jrebindir}/orbd \
    --slave %{_bindir}/policytool  policytool  %{jrebindir}/policytool \
    --slave %{_bindir}/rmid        rmid        %{jrebindir}/rmid \
    --slave %{_bindir}/rmiregistry rmiregistry %{jrebindir}/rmiregistry \
    --slave %{_bindir}/servertool  servertool  %{jrebindir}/servertool \
    --slave %{_bindir}/tnameserv   tnameserv   %{jrebindir}/tnameserv

  update-alternatives --install %{_jvmdir}/jre-%{origin} \
    jre_%{origin} %{_jvmdir}/%{jrelnk} %{priority} \
    --slave %{_jvmjardir}/jre-%{origin} jre_%{origin}_exports \
      %{_jvmjardir}/%{jrelnk}

  update-alternatives --install %{_jvmdir}/jre-%{javaver} \
    jre_%{javaver} %{_jvmdir}/%{jrelnk} %{priority} \
    --slave %{_jvmjardir}/jre-%{javaver} jre_%{javaver}_exports \
      %{_jvmjardir}/%{jrelnk}

%post devel

  update-alternatives --install %{_bindir}/javac \
    javac %{sdkbindir}/javac %{priority} \
    --slave %{_jvmdir}/java         java_sdk        %{_jvmdir}/%{sdklnk} \
    --slave %{_jvmjardir}/java      java_sdk_exports %{_jvmjardir}/%{sdklnk} \
    --slave %{_bindir}/appletviewer appletviewer    %{sdkbindir}/appletviewer \
    --slave %{_bindir}/extcheck     extcheck        %{sdkbindir}/extcheck \
    --slave %{_bindir}/idlj         idlj            %{sdkbindir}/idlj \
    --slave %{_bindir}/jar          jar             %{sdkbindir}/jar \
    --slave %{_bindir}/jarsigner    jarsigner       %{sdkbindir}/jarsigner \
    --slave %{_bindir}/javadoc      javadoc         %{sdkbindir}/javadoc \
    --slave %{_bindir}/javah        javah           %{sdkbindir}/javah \
    --slave %{_bindir}/javap        javap           %{sdkbindir}/javap \
    --slave %{_bindir}/jdb          jdb             %{sdkbindir}/jdb \
    --slave %{_bindir}/native2ascii native2ascii    %{sdkbindir}/native2ascii \
    --slave %{_bindir}/rmic         rmic            %{sdkbindir}/rmic \
    --slave %{_bindir}/serialver    serialver       %{sdkbindir}/serialver \

  update-alternatives --install %{_jvmdir}/java-%{origin} \
    java_sdk_%{origin} %{_jvmdir}/%{sdklnk} %{priority} \
    --slave %{_jvmjardir}/java-%{origin} java_sdk_%{origin}_exports \
      %{_jvmjardir}/%{sdklnk}

  update-alternatives --install %{_jvmdir}/java-%{javaver} \
    java_sdk_%{javaver} %{_jvmdir}/%{sdklnk} %{priority} \
      --slave %{_jvmjardir}/java-%{javaver} java_sdk_%{javaver}_exports \
        %{_jvmjardir}/%{sdklnk}

%postun

  if [ $1 -eq 0 ]; then
    update-alternatives --remove java                %{jrebindir}/java
    update-alternatives --remove jre_%{origin}       %{_jvmdir}/%{jrelnk}
    update-alternatives --remove jre_%{javaver}      %{_jvmdir}/%{jrelnk}
  fi

%postun devel

  if [ $1 -eq 0 ]; then
    update-alternatives --remove javac               %{sdkbindir}/javac
    update-alternatives --remove java_sdk_%{origin}  %{_jvmdir}/%{sdklnk}
    update-alternatives --remove java_sdk_%{javaver} %{_jvmdir}/%{sdklnk}
  fi

# We do not care if all/any of this actually succeeds
# Therefore errors are catched but messages allowed
%post fonts
{
  # Legacy font handling
  %{_bindir}/ttmkfdir -d %{fontdir} -o %{fontdir}/fonts.scale

  # Mandrake workaround
  %{_bindir}/perl -pi -e 's@0-c-0@0-p-0@g' %{fontdir}/fonts.scale

  %{x11bindir}/mkfontdir -e %{x11encdir} -e %{x11encdir}/large %{fontdir}

  %{_sbindir}/chkfontpath -q -a %{fontdir}

  # The following commands will be executed on upgrade by their respective
  # packages

  # Late legacy font handling
  if [ -x %{_bindir}/redhat-update-gnome-font-install ] ; then
      %{_bindir}/redhat-update-gnome-font-install
  fi
  if [ -x %{_bindir}/redhat-update-gnome-font-install2 ] ; then
      %{_bindir}/redhat-update-gnome-font-install2
  fi

  # Modern font handling
  if [ -x %{_bindir}/fc-cache ] ; then
    %{_bindir}/fc-cache -f %{_datadir}/fonts
  fi
} || :

%preun fonts

  if [ $1 -eq 0 ] ; then
    # Unregister self in fontconfig aliases
    if [ -w %{fontconfigdir}/fonts.conf ] ; then
      TMPFILE=$(mktemp -q /tmp/fonts.conf.XXXXXX) && \
      %{_bindir}/xsltproc --novalid %{xsldir}/unregister-java-fonts.xsl \
        %{fontconfigdir}/fonts.conf > $TMPFILE && \
      cat $TMPFILE > %{fontconfigdir}/fonts.conf && rm $TMPFILE
    fi
  fi

# We do not care if all/any of this actually succeeds
# Therefore errors are catched but messages allowed
%postun fonts
{
  # Rehash the font dir to keep only stuff manually installed
  [ $1 -eq 0 ] || exit 0

  if [ -d %{fontdir} ] && [ $(%{_bindir}/find %{fontdir} \
        -follow -type f -iname "*.ttf" -printf "\b\b\b\btrue") ] ; then
    %{_bindir}/ttmkfdir -d %{fontdir} -o %{fontdir}/fonts.scale
    %{x11bindir}/mkfontdir -e %{x11encdir} -e %{x11encdir}/large %{fontdir}
  else
    %{_sbindir}/chkfontpath -q -r %{fontdir}
  fi

  if [ -x %{_bindir}/redhat-update-gnome-font-install ] ; then
    %{_bindir}/redhat-update-gnome-font-install
  fi
  if [ -x %{_bindir}/redhat-update-gnome-font-install2 ] ; then
    %{_bindir}/redhat-update-gnome-font-install2
  fi

  if [ -x %{_bindir}/fc-cache ] ; then
    %{_bindir}/fc-cache -f %{_datadir}/fonts
  fi
} || :

%triggerin fonts -- fontconfig, %{fontconfigdir}/fonts.conf

  TMPFILE=$(mktemp -q /tmp/fonts.conf.XXXXXX) && \
  %{_bindir}/xsltproc --novalid %{xsldir}/register-java-fonts.xsl \
    %{fontconfigdir}/fonts.conf > $TMPFILE && \
  cat $TMPFILE > %{fontconfigdir}/fonts.conf && rm $TMPFILE


%clean
rm -rf $RPM_BUILD_ROOT


%files -f %{name}-%{version}.files
%defattr(-,root,root,-)
%doc _docs/*
%dir %{_jvmdir}/%{sdkdir}
%dir %{jvmjardir}
%{jvmjardir}/*.jar
%{_jvmdir}/%{jrelnk}
%{_jvmjardir}/%{jrelnk}
%dir %{_jvmdir}/%{jredir}/lib/security
%{_jvmdir}/%{jredir}/lib/security/*.jar
%config(noreplace) %{_jvmdir}/%{jredir}/lib/security/cacerts
%config(noreplace) %{_jvmdir}/%{jredir}/lib/security/java.policy
%config(noreplace) %{_jvmdir}/%{jredir}/lib/security/java.security

%files devel -f %{name}-%{version}-sdk-bin.files
%defattr(-,root,root,-)
%doc _docs/*
%dir %{_jvmdir}/%{sdkdir}/bin
%{_jvmdir}/%{sdkdir}/include
%{_jvmdir}/%{sdkdir}/lib
%{_jvmdir}/%{sdklnk}
%{_jvmjardir}/%{sdklnk}

%files console
%defattr(-,root,root,-)
%dir %{_jvmdir}/%{sdkdir}/bin
%{_jvmdir}/%{sdkdir}/bin/console
%dir %{_jvmdir}/%{sdkdir}/console
%{_jvmdir}/%{sdkdir}/console/lib
%{_jvmdir}/%{sdkdir}/console/*.jar
%doc %{_jvmdir}/%{sdkdir}/console/README.txt

%files jdbc -f %{name}-%{version}-jdbc.files
%defattr(-,root,root,-)

%files fonts
%defattr(-,root,root,-)
%dir %{fontdir}
%{fontdir}/*.ttf
%config(noreplace) %{fontdir}/fonts.alias
%ghost %{fontdir}/fonts.dir
%ghost %{fontdir}/fonts.scale
%ghost %{fontdir}/fonts.cache-1
%ghost %{fontdir}/XftCache
%ghost %{fontdir}/encodings.dir
%{xsldir}


%changelog
* Sat Dec 27 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.4.1.05.1jpp
- Update to 1.4.1.05 (JRockit 8.1 SP2).

* Thu Aug 21 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.4.1.03-2jpp
- Remove the java and javac alternatives on erase.

* Sat Jul 19 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.4.1.03-1jpp
- Update to 1.4.1.03 (JRockit 8.1 SP1).  Release notes:
  http://e-docs.bea.com/wljrockit/docs81/relnotes/relnotes.html
- Mark cacerts, java.policy and java.security as %%config(noreplace).

* Sat Jul 12 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.4.1.02-1jpp
- First build.
